<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML 3.0//EN" "html.dtd">
<HTML>

<HEAD>
<TITLE>PHP Firewall Generator -- Start Here</TITLE>
<?php

#############################################################################
#
# $Id: index.php3,v 1.20 1999/12/19 05:53:48 del Exp $
#
# PHP Firewall Generator by Del <del@babel.com.au>.  Original coding ideas
# from IPCHAINS-FIREWALL V1.6.2m by Ian Hall-Beyer (manuka@nerdherd.net)
# and various others.
#
# (C) Del under the GPL.
#
#############################################################################

#
# Define some constants.
#

$CONF="/var/lib/phpfwgen";

#############################################################################
#
# Read in all definitions.
#
#############################################################################

$interfaces = file("$CONF/interfaces");

$protocolr = file("/etc/protocols");
while ( list( $key, $val ) = each($protocolr) ) {
  #
  # Skip blank lines and comments
  #
  if ( strlen($val) < 5 ) continue;
  if ( substr($val, 0, 1) == "#" ) continue;
  $exploded = preg_split ("/[\s\/]+/", $val);
  $protocols[$exploded[0]] = intval($exploded[1]);
  $port = intval($exploded[1]);
}
asort($protocols);

$servicer = file("/etc/services");
# Stuff at the top ...
$services["HIPORTS/udp"] = "1024:65535";
$services["HIPORTS/tcp"] = "1024:65535";
while ( list($key,$val ) = each($servicer) ) {
  #
  # Skip blank lines and comments
  #
  if ( strlen($val) < 5 ) continue;
  if ( substr($val, 0, 1) == "#" ) continue;
  $exploded = preg_split ("/[\s\/]+/", $val);
  $service = $exploded[0];
  $port = intval($exploded[1]);
  $proto = $exploded[2];
  $services["$service/$proto"] = $port;
}
asort($services);
#
# Add the ICMP types
#
$icmpp = popen("/sbin/ipchains -h icmp", "r");
# Discard first 3 lines of header
$buffer = fgets($icmpp, 255);
$buffer = fgets($icmpp, 255);
$buffer = fgets($icmpp, 255);
# Slurp the rest in
while (!feof($icmpp)) {
  $buffer = trim(fgets($icmpp, 255));
  $buffer = ereg_replace(" .*$","",$buffer);
  if (empty($buffer)) continue;
  $services["$buffer/icmp"] = "ICMP";
}
$term = pclose($icmpp);

function read_config() {
  global $CONF;

  $configr = file("$CONF/config");
  while ( list($key,$val ) = each($configr) ) {
    #
    # Skip blank lines and comments
    #
    if ( strlen($val) < 5 ) continue;
    if ( substr($val, 0, 1) == "#" ) continue;
    $exploded = explode (" ", $val);
    $config[$exploded[0]] = chop($exploded[1]);
  }
  return $config;
}

function write_config($config) {
  global $CONF;

  $conffile = fopen ("$CONF/config","w+");
  reset($config);
  while ( list($key,$val) = each($config) ) {
    fwrite ($conffile, "$key $val\n");
  }
  fclose($conffile);
}

function read_objects() {
  global $CONF;

  $netobjectr = file("$CONF/netobjects");
  while ( list($key,$val ) = each($netobjectr) ) {
    #
    # Skip blank lines and comments
    #
    if ( strlen($val) < 5 ) continue;
    if ( substr($val, 0, 1) == "#" ) continue;
    $exploded = explode (" ", $val);
    $netobjects[$exploded[0]] = "$exploded[1] $exploded[2] " . chop($exploded[3]);
  }
  return $netobjects;
}

function write_objects($netobjects) {
  global $CONF;

  $objfile = fopen ("$CONF/netobjects","w+");
  reset($netobjects);
  while ( list($key,$val) = each($netobjects) ) {
    fwrite ($objfile, "$key $val\n");
  }
  fclose($objfile);
}

function read_rulesets() {
  global $CONF;

  $ruler = file("$CONF/rulesets");
  $rulekey = 100;
  while ( list( $key, $val ) = each($ruler) ) {
    #
    # Skip blank lines and comments
    #
    if ( strlen($val) < 5 ) continue;
    if ( substr($val, 0, 1) == "#" ) continue;
    $rules[$rulekey] = chop($val);
    $rulekey += 100;
  }
  return $rules;
}

function write_rulesets($rules) {
  global $CONF;

  $rulefile = fopen ("$CONF/rulesets","w+");
  reset($rules);
  while ( list($key,$val) = each($rules) ) {
    fwrite ($rulefile, "$val\n");
  }
  fclose ($rulefile);
}

function read_portfwds() {
  global $CONF;

  $ruler = file("$CONF/portfwds");
  $rulekey = 100;
  while ( list($key,$val ) = each($ruler) ) {
    #
    # Skip blank lines and comments
    #
    if ( strlen($val) < 5 ) continue;
    if ( substr($val, 0, 1) == "#" ) continue;
    $rules[$rulekey] = chop($val);
    $rulekey += 100;
  }
  return $rules;
}

function write_portfwds($portfwds) {
  global $CONF;

  $rulefile = fopen ("$CONF/portfwds","w+");
  reset($portfwds);
  while ( list($key,$val) = each($portfwds) ) {
    fwrite ($rulefile, "$val\n");
  }
  fclose ($rulefile);
}

function read_redirectors() {
  global $CONF;

  $ruler = file("$CONF/redirectors");
  $rulekey = 100;
  while ( list($key,$val ) = each($ruler) ) {
    #
    # Skip blank lines and comments
    #
    if ( strlen($val) < 5 ) continue;
    if ( substr($val, 0, 1) == "#" ) continue;
    $rules[$rulekey] = chop($val);
    $rulekey += 100;
  }
  return $rules;
}

function write_redirectors($redirectors) {
  global $CONF;

  $rulefile = fopen ("$CONF/redirectors","w+");
  reset($redirectors);
  while ( list($key,$val) = each($redirectors) ) {
    fwrite ($rulefile, "$val\n");
  }
  fclose ($rulefile);
}

$config = read_config();
$netobjects = read_objects();
$rules = read_rulesets();
$portfwds = read_portfwds();
$redirectors = read_redirectors();

#############################################################################
#
# Utility functions.
#
#############################################################################

function service_colour($key) {
  global $services;

  if (ereg ("ALL",$key)) return "<FONT COLOR=\"#FF0000\">";
  if (ereg ("HIPORTS",$key)) return "<FONT COLOR=\"#FF0000\">";

  $port = $services[$key];
  $exploded = preg_split ("/[\s\/]+/", $key);
  $proto = $exploded[1];

  if ($port < 1024) {
    if ($proto == "tcp") {
      $fs = "<FONT COLOR=\"#CC00CC\">";
    } elseif ($proto == "udp") {
      $fs = "<FONT COLOR=\"#EE0000\">";
    } else {
      $fs = "<FONT COLOR=\"#0000CC\">";
    }
  } else {
    if ($proto == "tcp") {
      $fs = "<FONT COLOR=\"#777700\">";
    } elseif ($proto == "udp") {
      $fs = "<FONT COLOR=\"#007777\">";
    } else {
      $fs = "<FONT COLOR=\"#0000EE\">";
    }
  }
  return $fs;
}

#############################################################################
#
# Form/Submit handler.
#
#############################################################################

#
# Check if there was a submission.
#
while ( is_array($HTTP_POST_VARS)
     && list($key, $val) = each($HTTP_POST_VARS)) {
  switch ($key) {

    #
    # Create a new network object.
    #
    case "createobject_x":
      if (empty($newobjectname) || empty($newnetaddr) || empty($newnetmask)) {
        break;
      }
      $netobjects[$newobjectname] = "$newnetaddr $newnetmask $newmasq";
      write_objects($netobjects);
    break;

    #
    # Delete a network object.
    #
    case "delobject_x":
      unset($netobjects[$objectname]);
      write_objects($netobjects);
    break;

    #
    # Create a firewall rule.
    #
    case "createrule_x":
      if (empty($newrulekey)) {
        $newrulekey = 99999;
      }
      if ($newport != "ALL") {
        $exploded = preg_split ("/[\s\/]+/", $newport);
        if ($newproto == "ALL") $newproto = $exploded[1];
        if ($newproto != $exploded[1]) break;
        $newport = $exploded[0];
      }
      $rules[$newrulekey] = "$source $dest $newproto $newport $action $log";
      ksort($rules);
      write_rulesets($rules);
      $rules = read_rulesets();
    break;

    #
    # Delete a firewall rule.
    #
    case "delrule_x":
      unset($rules[$rulekey]);
      write_rulesets($rules);
      $rules = read_rulesets();
    break;

    #
    # Create a port forwarding rule.
    #
    case "createportfwd_x":
      if (empty($newportfwdkey)) {
        $newportfwdkey = 99999;
      }
      $exploded = preg_split ("/[\s\/]+/", $newsrcport);
      $newproto = $exploded[1];
      $srcport = $exploded[0];
      $exploded = preg_split ("/[\s\/]+/", $newdstport);
      $dstport = $exploded[0];
      $portfwds[$newportfwdkey] = "$newproto $source $srcport $dest $dstport";
      ksort($portfwds);
      write_portfwds($portfwds);
      $portfwds = read_portfwds();
    break;

    #
    # Delete a port forwarding rule.
    #
    case "delportfwd_x":
      unset($portfwds[$portfwdkey]);
      write_portfwds($portfwds);
      $portfwds = read_portfwds();
    break;

    #
    # Create a redirector rule.
    #
    case "createredirector_x":
      if (empty($newredirectorkey)) {
        $newredirectorkey = 99999;
      }
      $exploded = preg_split ("/[\s\/]+/", $newsrcport);
      $newproto = $exploded[1];
      $srcport = $exploded[0];
      $exploded = preg_split ("/[\s\/]+/", $newdstport);
      $dstport = $exploded[0];
      $redirectors[$newredirectorkey] = "$source $dest $newproto $srcport $dstport";
      ksort($redirectors);
      write_redirectors($redirectors);
      $redirectors = read_redirectors();
    break;

    #
    # Delete a redirector rule.
    #
    case "delredirector_x":
      unset($redirectors[$redirectorkey]);
      write_redirectors($redirectors);
      $redirectors = read_redirectors();
    break;

    #
    # Config stuff.
    #
    case "showinterfaces":
      $config[SHOW_INTERFACES] = "YES";
      write_config($config);
    break;
    case "hideinterfaces":
      $config[SHOW_INTERFACES] = "NO";
      write_config($config);
    break;
    case "shownetobjects":
      $config[SHOW_NETOBJECTS] = "YES";
      write_config($config);
    break;
    case "hidenetobjects":
      $config[SHOW_NETOBJECTS] = "NO";
      write_config($config);
    break;
    case "showrules":
      $config[SHOW_RULES] = "YES";
      write_config($config);
    break;
    case "hiderules":
      $config[SHOW_RULES] = "NO";
      write_config($config);
    break;
    case "showprotocols":
      $config[SHOW_PROTOCOLS] = "YES";
      write_config($config);
    break;
    case "hideprotocols":
      $config[SHOW_PROTOCOLS] = "NO";
      write_config($config);
    break;
    case "showservices":
      $config[SHOW_SERVICES] = "YES";
      write_config($config);
    break;
    case "hideservices":
      $config[SHOW_SERVICES] = "NO";
      write_config($config);
    break;
    case "showportfwd":
      $config[SHOW_PORTFWD] = "YES";
      write_config($config);
    break;
    case "hideportfwd":
      $config[SHOW_PORTFWD] = "NO";
      write_config($config);
    break;
    case "showredirect":
      $config[SHOW_REDIRECT] = "YES";
      write_config($config);
    break;
    case "hideredirect":
      $config[SHOW_REDIRECT] = "NO";
      write_config($config);
    break;
    case "showports":
      $config[SHOW_PORTS] = "YES";
      write_config($config);
    break;
    case "hideports":
      $config[SHOW_PORTS] = "NO";
      write_config($config);
    break;
    case "showscript":
      $config[SHOW_SCRIPT] = "YES";
      write_config($config);
    break;
    case "hidescript":
      $config[SHOW_SCRIPT] = "NO";
      write_config($config);
    break;

    case "sendemail":
      $message = implode (file("$CONF/firewall"), "");
      mail($emailaddress, "Firewall script", $message);
    break;

    default:
      # print "$key ";
    break;
  } # end switch
} # end while
?>

</HEAD>

<BODY BGCOLOR="#FFFFFF">

<TABLE BORDER=0 CELLSPACING=2 CELLPADDING=4>

<TR><TD>&nbsp;</TD><TD><HR></TD></TR>

<TR><TD ALIGN=LEFT VALIGN=TOP><B>Introduction</B></TD>
<TD>

<A HREF="http://www.php.net/"><IMG SRC="phplogo1.gif" ALT="Powered by PHP" ALIGN=RIGHT BORDER=0></A>
This a PHP based firewall script
generator for ipchains based firewalls on Linux.
<P>
(c)
<A HREF="mailto:del@babel.com.au">Del</A>
1999 under the
<A HREF="http://www.gnu.org/copyleft/gpl.html">GPL</A>
<P>

Here are some very basic instructions:
<P>

<UL>
<LI>Make sure that your /etc/services file and /etc/protocols file
are correct.  You can't define any rules in your firewall for services
or protocols that don't exist in these files.
<LI>Make sure the interface list is correct.  This is for reference
purposes only and isn't actually used anywhere in the program, but
it does give you a sanity check to make sure that everything is defined
the way it should be.
<LI>Enter all of your network objects.
<LI>Enter your firewall rules, including port forwarding rules (used to
hide a server behind the firewall) and redirector rules (used for transparent
proxying of services to a proxy server on the firewall).
<LI>Once your firewall rules are entered, check the script at the bottom
of the page.  You can cut and paste this into a text editor and use it
as your firewall script.  You can also have it e-mailed to you.  The
script is also stored in /var/lib/phpfwgen/firewall if you want to
install it into your system startup folders.
</UL>

TODO:
<P>

<UL>
<LI>Better graphics.  Help wanted!!
<LI>Install the script automatically.
<LI>Support for
<A HREF="http://netfilter.kernelnotes.org/">NAT/iptables/ipfilter</A>
<LI>Currently a rule that allows all outgoing traffic on all ports
also allows all incoming non-SYN traffic on all ports (for TCP responses).
It'd be better to allow only incoming traffic on the ports that were
actually in use for outgoing socket connections, but this isn't possible
in ipchains.  Currently this is attempted for UDP by allowing incoming
packets packets on
the high ports (1024:65535) but this is unsuitable since many programs
now bind to UDP ports in this range for incoming connections,
and also these ports are often used for hacks (eg: NetBus, BackOrifice).
Find a good solution to this problem!
<LI>A partial solution is to DENY incoming connections on known bad
UDP ports (eg: 12345 and 23456 for NetBus).  These
must be in place before other (legal)
outgoing UDP connections (eg: for DNS).
<LI>A better solution might be to use the stateful packet filtering
code at ftp://ftp.interlinx.bc.ca/pub/spf/
<LI>Find a more comprehensive /etc/services file somewhere.
</UL>

CREDITS:
<P>

I got some ideas from various places, including Godot's Muse and
IPCHAINS-FIREWALL V1.6.2m by Ian Hall-Beyer (manuka@nerdherd.net)
<P>

<?php
#
# Do some checks for installed software.
#
if (! file_exists("/sbin/ipchains") ) {
print "<FONT COLOR=\"#FF0000\">";
print "Warning!  /sbin/ipchains is not installed on this system.  The ";
  print "firewall script will not work without it.  You should install the ";
  print "ipchains package from your Linux distribution CD.";
  print "</FONT><P>\n";
}

if (! file_exists("/usr/sbin/ipmasqadm") ) {
  print "<FONT COLOR=\"#FF0000\">";
  print "Warning!  /usr/sbin/ipmasqadm is not installed on this system. ";
  print "Port forwarding will not work without it.  You should install the ";
  print "ipmasqadm RPM from the RedHat/contrib FTP site.";
  print "</FONT><P>\n";
}
?>

<HR></TD></TR>

<?php
#############################################################################
#
# Interfaces.
#
#############################################################################
?>

<TR><TD ALIGN=LEFT VALIGN=TOP><B>Interfaces</B>
<BR>
<FORM NAME="button" METHOD="POST" ACTION="index.php3">
<?php if ($config[SHOW_INTERFACES] == "YES") { ?>
  <INPUT TYPE="SUBMIT" NAME="hideinterfaces" VALUE="Hide">
<?php } else { ?>
  <INPUT TYPE="SUBMIT" NAME="showinterfaces" VALUE="Show">
<?php } ?>
</FORM>
</TD>

<TD>

The interface list is for reference purposes only.  You cannot add or
delete interfaces here.  To add or delete interfaces, insert or remove
network adapters / drivers from your machine, and use the Red Hat
"netcfg" program.
<P>

<?php if ($config[SHOW_INTERFACES] == "YES") { ?>

<TABLE BORDER=0 BGCOLOR="#EEEEEE" CELLSPACING=2 CELLPADDING=4>
  <TR ALIGN=LEFT VALIGN=TOP><TD><B>Interface Name</B></TD></TR>

<?php

#
# Print all of the interface definitions.
#
function print_interface ($interface) {
  print "<TR VALIGN=TOP ALIGN=LEFT><TD>$interface</TD></TR>\n";
}

if (is_array($interfaces)) {
  reset($interfaces);
  array_walk( $interfaces, 'print_interface' );
}

?>

</TABLE>

<?php } ?>

<HR></TD></TR>

<?php
#############################################################################
#
# Network Objects.
#
#############################################################################
?>

<TR><TD ALIGN=left VALIGN=top><B>Network Objects</B>
<BR>
<FORM NAME="button" METHOD="POST" ACTION="index.php3">
<?php if ($config[SHOW_NETOBJECTS] == "YES") { ?>
  <INPUT TYPE="SUBMIT" NAME="hidenetobjects" VALUE="Hide">
<?php } else { ?>
  <INPUT TYPE="SUBMIT" NAME="shownetobjects" VALUE="Show">
<?php } ?>
</FORM>
</TD>
<TD>

Enter all of your network objects here.  For example, make sure that
all of your internal networks are defined.  If there are external
hosts or networks that you need to define rules for, add them here.
You can add an object definition in the form at the bottom of the
object list.
<P>

The network mask can be entered as a dotted netmask (eg: 255.255.255.0)
or as a number of network bits to include in the mask (eg: 24).  For
example, the values 255.255.255.255 and 32 are identical.
<P>

<?php if ($config[SHOW_NETOBJECTS] == "YES") { ?>
<TABLE BORDER=0 BGCOLOR="#EEEEEE" CELLSPACING=2 CELLPADDING=2>
  <TR ALIGN=LEFT VALIGN=MIDDLE>
    <TD><B>Object Name</B></TD>
    <TD><B>Network Address</B></TD>
    <TD><B>Network Mask</B></TD>
    <TD><B>Masquerade</B></TD>
    <TD><B>Add/Delete</B></TD>
  </TR>

<?php

#
# Print all of the network object definitions.
#
function print_netobject ($netobject, $value) {
  list ($address, $mask, $masq) = preg_split ("/[\s]+/", $value);
  print "<TR ALIGN=LEFT VALIGN=MIDDLE>";
  print "<TD>$netobject</TD><TD>$address</TD><TD>$mask</TD><TD>$masq</TD>";
  print "<TD>";
  print "<FORM NAME=\"rmobject\" METHOD=\"POST\" ACTION=\"index.php3\">";
  print "<INPUT TYPE=\"HIDDEN\" NAME=\"objectname\" VALUE=\"$netobject\">";
  print "<INPUT TYPE=IMAGE SRC=mini-cross.gif NAME=delobject BORDER=0>";
  print "</FORM>";
  print "</TD>";
  print "</TR>\n";
}

if (is_array($netobjects)) {
  reset($netobjects);
  while ( list($key,$val) = each($netobjects) ) {
    print_netobject ($key, $val);
  }
}

#
# A form to add a network object.
#
?>

<FORM NAME="addobject" METHOD="POST" ACTION="index.php3">
  <TR ALIGN=LEFT VALIGN=MIDDLE>
    <TD><INPUT TYPE="TEXT" NAME="newobjectname" SIZE=12 MAXLENGTH=32 VALUE=""></TD>
    <TD><INPUT TYPE="TEXT" NAME="newnetaddr" SIZE=10 MAXLENGTH=15 VALUE=""></TD>
    <TD><INPUT TYPE="TEXT" NAME="newnetmask" SIZE=10 MAXLENGTH=15 VALUE=""></TD>
    <TD><SELECT NAME="newmasq">
        <OPTION SELECTED>YES
        <OPTION>NO
        </SELECT>
    </TD>
    <TD><INPUT TYPE=IMAGE SRC=mini-tick.gif NAME=createobject BORDER=0></TD>
  </TR>
</FORM>

</TABLE>
<?php } ?>

<HR></TD></TR>

<?php
#############################################################################
#
# Firewall Rules.
#
#############################################################################
?>

<TR><TD ALIGN=left VALIGN=top><B>Firewall Rules</B>
<FORM NAME="button" METHOD="POST" ACTION="index.php3">
<?php if ($config[SHOW_RULES] == "YES") { ?>
  <INPUT TYPE="SUBMIT" NAME="hiderules" VALUE="Hide">
<?php } else { ?>
  <INPUT TYPE="SUBMIT" NAME="showrules" VALUE="Show">
<?php } ?>
</FORM>
</TD>
<TD>

Enter your firewall rules here.  You need to enter the following
for each rule:
<UL>
<LI><B>Rule Number</B>: This defines where the rule is entered into
the list.  For example, to enter a new rule between 100 and 200,
number it "150".  The rules will be re-numbered on each iteration
of the firewall, so you can continue entering rules between each
new pair of rules.  If you leave this blank then the rule will go
at the end of the rule set.
<LI><B>Source</B>: Select a source network object (where the packet
is coming from).
<LI><B>Destination</B>: Select a destination network object (where the packet
is going to).
<LI><B>Protocol</B>: Select a network protocol, or ALL for all protocols.
<LI><B>Service</B>: Select a network port, or ALL for all ports.  Note that
most ports will also define a protocol, eg: telnet/tcp is for the tcp
protocol.
<LI><B>Action</B>: This will be ACCEPT or DENY.
<LI><B>Log</B>: YES to log the packet, NO to not bother logging it.
</UL>

Note that if you have masqueraded networks, then you need to enter explicit
ACCEPT rules for each of those networks.
<P>

<?php if ($config[SHOW_RULES] == "YES") { ?>
<TABLE BORDER=0 BGCOLOR="#EEEEEE" CELLSPACING=2 CELLPADDING=4>
  <TR ALIGN=LEFT VALIGN=MIDDLE>
    <TD><B>Rule Number</B></TD>
    <TD><B>Source</B></TD>
    <TD><B>Destination</B></TD>
    <TD><B>Protocol</B></TD>
    <TD><B>Service</B></TD>
    <TD><B>Action</B></TD>
    <TD><B>Log</B></TD>
    <TD><B>Add/Delete</B></TD>
  </TR>

<?php

#
# Print all of the firewall rules.
#
function print_rule ($key, $rule) {
  list ($source, $dest, $proto, $port, $action, $log) = preg_split ("/[\s]+/", $rule);
  print "<TR ALIGN=LEFT VALIGN=MIDDLE>";
  print "<TD>$key</TD>";
  print "<TD>$source</TD><TD>$dest</TD>";
  $fs = service_colour("$port/$proto");
  print "<TD>$fs$proto</FONT></TD><TD>$fs$port</FONT></TD>";
  print "<TD>$action</TD><TD>$log</TD>";
  print "<TD>";
  print "<FORM NAME=\"rmrule\" METHOD=\"POST\" ACTION=\"index.php3\">";
  print "<INPUT TYPE=\"HIDDEN\" NAME=\"rulekey\" VALUE=\"$key\">";
  print "<INPUT TYPE=IMAGE SRC=mini-cross.gif NAME=delrule BORDER=0>";
  print "</FORM>";
  print "</TD>";
  print "</TR>\n";
}

if (is_array($rules)) {
  reset($rules);
  while ( list($key,$val) = each($rules) ) {
    print_rule ($key, $val);
  }
}

#
# A form to add a rule.
#
?>

<FORM NAME="addrule" METHOD="POST" ACTION="index.php3">
  <TR ALIGN=LEFT VALIGN=MIDDLE>
    <TD><INPUT TYPE="TEXT" NAME="newrulekey" SIZE=5 MAXLENGTH=5 VALUE=""></TD>
    <TD><SELECT NAME="source">
<?php
reset($netobjects);
while ( list($key,$val) = each($netobjects) ) {
  if ($key == "ALL") {
    print "<OPTION SELECTED>$key\n";
  } else {
    print "<OPTION>$key\n";
  }
}
?>
        </SELECT>
    </TD>
    <TD><SELECT NAME="dest">
<?php
reset($netobjects);
while ( list($key,$val) = each($netobjects) ) {
  if ($key == "ALL") {
    print "<OPTION SELECTED>$key\n";
  } else {
    print "<OPTION>$key\n";
  }
}
?>
        </SELECT>
    </TD>
    <TD><SELECT NAME="newproto">
        <OPTION SELECTED>ALL
<?php
reset($protocols);
while ( list($key,$val) = each($protocols) ) {
  print "<OPTION>$key\n";
}
?>
        </SELECT>
    </TD>
    <TD><SELECT NAME="newport">
        <OPTION SELECTED>ALL
<?php
reset($services);
while ( list($key,$val) = each($services) ) {
  print "<OPTION>$key\n";
}
?>
        </SELECT>
    </TD>
    <TD><SELECT NAME="action">
        <OPTION SELECTED>ACCEPT
        <OPTION>DENY
        </SELECT>
    </TD>
    <TD><SELECT NAME="log">
        <OPTION SELECTED>YES
        <OPTION>NO
        </SELECT>
    </TD>
    <TD><INPUT TYPE=IMAGE SRC=mini-tick.gif NAME=createrule BORDER=0></TD>
  </TR>
</FORM>

</TABLE>
<?php } ?>

<HR></TD></TR>

<?php
#############################################################################
#
# Port Forward Rules.
#
#############################################################################
?>

<TR><TD ALIGN=left VALIGN=top><B>Port Forwarding Rules</B>
<FORM NAME="button" METHOD="POST" ACTION="index.php3">
<?php if ($config[SHOW_PORTFWD] == "YES") { ?>
  <INPUT TYPE="SUBMIT" NAME="hideportfwd" VALUE="Hide">
<?php } else { ?>
  <INPUT TYPE="SUBMIT" NAME="showportfwd" VALUE="Show">
<?php } ?>
</FORM>
</TD>
<TD>

Enter your port forwarding rules here.  You need to enter the
following for each rule:
<UL>
<LI><B>Rule Number</B>: This defines where the rule is entered into
the list.  For example, to enter a new rule between 100 and 200,
number it "150".  The rules will be re-numbered on each iteration
of the firewall, so you can continue entering rules between each
new pair of rules.  If you leave this blank then the rule will go
at the end of the rule set.
<LI><B>Protocol</B>: Select a network protocol, udp or tcp.
<LI><B>From</B>: Where the forwarding is starting from (where the packet
is originally sent to by the source).
<LI><B>From Port</B>: What port the forwarding is starting from
(what port the packet was originally sent to).
<LI><B>Destination</B>: Select a destination network object (where the packet
is to be forwarded to).
<LI><B>Destination Port</B>: Select a destination network port (what port
the packet is to be forwarded to).
</UL>

Note that the <B>From Port</B> and <B>Destination Port</B> must both use
the same protocol.  You cannot port forward a TCP connection to a UDP port.
<P>

<?php if ($config[SHOW_PORTFWD] == "YES") { ?>
<TABLE BORDER=0 BGCOLOR="#EEEEEE" CELLSPACING=2 CELLPADDING=4>
  <TR ALIGN=LEFT VALIGN=MIDDLE>
    <TD><B>Rule Number</B></TD>
    <TD><B>Protocol</B></TD>
    <TD><B>From</B></TD>
    <TD><B>From Port</B></TD>
    <TD><B>Destination</B></TD>
    <TD><B>Destination Port</B></TD>
    <TD><B>Add/Delete</B></TD>
  </TR>

<?php

#
# Print all of the port forwarding rules.
#
function print_portfwd ($key, $rule) {
  list ($proto, $source, $sport, $dest, $dport) = preg_split ("/[\s]+/", $rule);
  print "<TR ALIGN=LEFT VALIGN=MIDDLE>";
  print "<TD>$key</TD>";
  $fs = service_colour("$sport/$proto");
  print "<TD>$fs$proto</FONT></TD>";
  print "<TD>$source</TD>";
  print "<TD>$fs$sport</FONT></TD>";
  print "<TD>$dest</TD>";
  $fs = service_colour("$dport/$proto");
  print "<TD>$fs$dport</FONT></TD>";
  print "<TD>";
  print "<FORM NAME=\"rmportfwd\" METHOD=\"POST\" ACTION=\"index.php3\">";
  print "<INPUT TYPE=\"HIDDEN\" NAME=\"portfwdkey\" VALUE=\"$key\">";
  print "<INPUT TYPE=IMAGE SRC=mini-cross.gif NAME=delportfwd BORDER=0>";
  print "</FORM>";
  print "</TD>";
  print "</TR>\n";
}

if (is_array($portfwds)) {
  reset($portfwds);
  while ( list($key,$val) = each($portfwds) ) {
    print_portfwd ($key, $val);
  }
}

#
# A form to add a port forwarding rule.
#
?>

<FORM NAME="addportfwd" METHOD="POST" ACTION="index.php3">
  <TR ALIGN=LEFT VALIGN=MIDDLE>
    <TD><INPUT TYPE="TEXT" NAME="newportfwdkey" SIZE=5 MAXLENGTH=5 VALUE=""></TD>
    <TD><SELECT NAME="newproto">
        <OPTION SELECTED>tcp
        <OPTION>udp
        </SELECT>
    </TD>
    <TD><SELECT NAME="source">
<?php
reset($netobjects);
while ( list($key,$val) = each($netobjects) ) {
  if ($key == "ALL") {
    print "<OPTION SELECTED>$key\n";
  } else {
    print "<OPTION>$key\n";
  }
}
?>
        </SELECT>
    </TD>
    <TD><SELECT NAME="newsrcport">
<?php
reset($services);
while ( list($key,$val) = each($services) ) {
  if (ereg ("/udp$|/tcp$", $key)) print "<OPTION>$key\n";
}
?>
        </SELECT>
    </TD>
    <TD><SELECT NAME="dest">
<?php
reset($netobjects);
while ( list($key,$val) = each($netobjects) ) {
  if ($key == "ALL") {
    print "<OPTION SELECTED>$key\n";
  } else {
    print "<OPTION>$key\n";
  }
}
?>
        </SELECT>
    </TD>
    <TD><SELECT NAME="newdstport">
<?php
reset($services);
while ( list($key,$val) = each($services) ) {
  if (ereg ("/udp$|/tcp$", $key)) print "<OPTION>$key\n";
}
?>
        </SELECT>
    </TD>
    <TD><INPUT TYPE=IMAGE SRC=mini-tick.gif NAME=createportfwd BORDER=0></TD>
  </TR>
</FORM>

</TABLE>
<?php } ?>

<HR></TD></TR>

<?php
#############################################################################
#
# Redirector Rules.
#
#############################################################################
?>

<TR><TD ALIGN=left VALIGN=top><B>Redirector Rules</B>
<FORM NAME="button" METHOD="POST" ACTION="index.php3">
<?php if ($config[SHOW_REDIRECT] == "YES") { ?>
  <INPUT TYPE="SUBMIT" NAME="hideredirect" VALUE="Hide">
<?php } else { ?>
  <INPUT TYPE="SUBMIT" NAME="showredirect" VALUE="Show">
<?php } ?>
</FORM>
</TD>
<TD>

Enter your redirector rules here.  You need to enter the
following for each rule:

<UL>
<LI><B>Rule Number</B>: This defines where the rule is entered into
the list.  For example, to enter a new rule between 100 and 200,
number it "150".  The rules will be re-numbered on each iteration
of the firewall, so you can continue entering rules between each
new pair of rules.  If you leave this blank then the rule will go
at the end of the rule set.
<LI><B>Source</B>: Select a source network object (where the packet
is coming from).
<LI><B>Destination</B>: Select a destination network object (where the packet
is going to).
<LI><B>Protocol</B>: Select a network protocol, udp or tcp.
<LI><B>From Port</B>: What port the redirection is starting from
(what port the packet was originally sent to).  For example, to redirect
traffic for external web servers, enter the port name <B>www</B>.
<LI><B>To Port</B>: Select the port that
the packet is to be redirected to.  For example, if you have a squid
proxy server on the firewall, listening on port <B>squidproxy</B>, then enter
the port name <B>squidproxy</B>.
</UL>

Note that the <B>From Port</B> and <B>To Port</B> must both use
the same protocol.  You cannot redirect a TCP connection to a UDP port.
<P>

You also need to have <B>CONFIG_IP_TRANSPARENT_PROXY</B> defined in your
kernel.  The connection will always be redirected to a socket on
the <B>local</B> (firewall) host -- if you want to redirect it elsewhere
then you must use <B>in.tproxyd</B> from the <B>transproxy</B> package.
<P>

<?php if ($config[SHOW_REDIRECT] == "YES") { ?>
<TABLE BORDER=0 BGCOLOR="#EEEEEE" CELLSPACING=2 CELLPADDING=4>
  <TR ALIGN=LEFT VALIGN=MIDDLE>
    <TD><B>Rule Number</B></TD>
    <TD><B>Source</B></TD>
    <TD><B>Destination</B></TD>
    <TD><B>Protocol</B></TD>
    <TD><B>From Port</B></TD>
    <TD><B>To Port</B></TD>
    <TD><B>Add/Delete</B></TD>
  </TR>

<?php

#
# Print all of the redirector rules.
#
function print_redirector ($key, $rule) {
  list ($source, $dest, $proto, $sport, $dport) = preg_split ("/[\s]+/", $rule);
  print "<TR ALIGN=LEFT VALIGN=MIDDLE>";
  print "<TD>$key</TD>";
  print "<TD>$source</TD>";
  print "<TD>$dest</TD>";
  $fs = service_colour("$sport/$proto");
  print "<TD>$fs$proto</FONT></TD>";
  print "<TD>$fs$sport</FONT></TD>";
  $fs = service_colour("$dport/$proto");
  print "<TD>$fs$dport</FONT></TD>";
  print "<TD>";
  print "<FORM NAME=\"rmredirect\" METHOD=\"POST\" ACTION=\"index.php3\">";
  print "<INPUT TYPE=\"HIDDEN\" NAME=\"redirectorkey\" VALUE=\"$key\">";
  print "<INPUT TYPE=IMAGE SRC=mini-cross.gif NAME=delredirector BORDER=0>";
  print "</FORM>";
  print "</TD>";
  print "</TR>\n";
}

if (is_array($redirectors)) {
  reset($redirectors);
  while ( list($key,$val) = each($redirectors) ) {
    print_redirector ($key, $val);
  }
}

#
# A form to add a redirector rule.
#
?>

<FORM NAME="addredirect" METHOD="POST" ACTION="index.php3">
  <TR ALIGN=LEFT VALIGN=MIDDLE>
    <TD><INPUT TYPE="TEXT" NAME="newredirectorkey" SIZE=5 MAXLENGTH=5 VALUE=""></TD
>
    <TD><SELECT NAME="source">
<?php
reset($netobjects);
while ( list($key,$val) = each($netobjects) ) {
  if ($key == "ALL") {
    print "<OPTION SELECTED>$key\n";
  } else {
    print "<OPTION>$key\n";
  }
}
?>
        </SELECT>
    </TD>
    <TD><SELECT NAME="dest">
<?php
reset($netobjects);
while ( list($key,$val) = each($netobjects) ) {
  if ($key == "ALL") {
    print "<OPTION SELECTED>$key\n";
  } else {
    print "<OPTION>$key\n";
  }
}
?>
        </SELECT>
    </TD>
    <TD><SELECT NAME="newproto">
        <OPTION SELECTED>tcp
        <OPTION>udp
        </SELECT>
    </TD>
    <TD><SELECT NAME="newsrcport">
<?php
reset($services);
while ( list($key,$val) = each($services) ) {
  if (ereg ("/udp$|/tcp$", $key)) print "<OPTION>$key\n";
}
?>
        </SELECT>
    </TD>
    <TD><SELECT NAME="newdstport">
<?php
reset($services);
while ( list($key,$val) = each($services) ) {
  if (ereg ("/udp$|/tcp$", $key)) print "<OPTION>$key\n";
}
?>
        </SELECT>
    </TD>
    <TD><INPUT TYPE=IMAGE SRC=mini-tick.gif NAME=createredirector BORDER=0></TD>
  </TR>
</FORM>

</TABLE>
<?php } ?>

<HR></TD></TR>

<?php
#############################################################################
#
# Protocols.
#
#############################################################################
?>

<TR><TD ALIGN=left VALIGN=top><B>Protocols (Reference)</B>
<FORM NAME="button" METHOD="POST" ACTION="index.php3">
<?php if ($config[SHOW_PROTOCOLS] == "YES") { ?>
  <INPUT TYPE="SUBMIT" NAME="hideprotocols" VALUE="Hide">
<?php } else { ?>
  <INPUT TYPE="SUBMIT" NAME="showprotocols" VALUE="Show">
<?php } ?>
</FORM>
</TD>
<TD>

The protocols table is for reference only.  You cannot add or delete
protocols here.  Please edit /etc/protocols if you need to add or
change any of these.
<P>

<?php if ($config[SHOW_PROTOCOLS] == "YES") { ?>
<TABLE BORDER=0 BGCOLOR="#EEEEEE" CELLSPACING=2 CELLPADDING=4>
  <TR ALIGN=LEFT VALIGN=TOP>
    <TD><B>Protocol Name</B></TD>
    <TD><B>Protocol Number</B></TD>
  </TR>

<?php

#
# Print all of the protocol definitions.
#
function print_protocol ($proto,$num) {
  print "<TR VALIGN=MIDDLE ALIGN=LEFT>";
  print "<TD>$proto</TD><TD>$num</TD></TR>\n";
}

reset($protocols);
while ( list($key,$val) = each($protocols) ) {
  print_protocol ($key, $val);
}

?>

</TABLE>
<?php } ?>

<HR></TD></TR>

<?php
#############################################################################
#
# Services.
#
#############################################################################
?>

<TR><TD ALIGN=left VALIGN=top><B>Services (Reference)</B>
<FORM NAME="button" METHOD="POST" ACTION="index.php3">
<?php if ($config[SHOW_SERVICES] == "YES") { ?>
  <INPUT TYPE="SUBMIT" NAME="hideservices" VALUE="Hide">
<?php } else { ?>
  <INPUT TYPE="SUBMIT" NAME="showservices" VALUE="Show">
<?php } ?>
</FORM>
</TD>
<TD>

The services table is for reference only.  You cannot add or delete
service definitions here.  Please edit /etc/services if you need to
add or change any of these.
<P>

<?php if ($config[SHOW_SERVICES] == "YES") { ?>
<TABLE BORDER=0 BGCOLOR="#EEEEEE" CELLSPACING=2 CELLPADDING=4>
  <TR ALIGN=LEFT VALIGN=TOP>
    <TD><B>Service Name</B></TD>
    <TD><B>Protocol</B></TD>
    <TD><B>Port Number</B></TD>
  </TR>

<?php

#
# Print all of the service definitions.
#
function print_service ($service,$proto,$port) {
  print "<TR VALIGN=MIDDLE ALIGN=LEFT>";
  $fs = "<TD>" . service_colour("$service/$proto");
  $ef = "</FONT></TD>";
  print "$fs$service$ef$fs$proto$ef$fs$port$ef</TR>\n";
}

reset($services);
while ( list( $key,$val ) = each($services) ) {
  $exploded = preg_split ("/[\s\/]+/", $key);
  print_service ($exploded[0], $exploded[1], $val);
}

?>

</TABLE>
<?php } ?>

<HR></TD></TR>

<?php
#############################################################################
#
# Open ports.
#
#############################################################################
?>

<TR><TD ALIGN=left VALIGN=top><B>Open Ports (Reference)</B>
<FORM NAME="button" METHOD="POST" ACTION="index.php3">
<?php if ($config[SHOW_PORTS] == "YES") { ?>
  <INPUT TYPE="SUBMIT" NAME="hideports" VALUE="Hide">
<?php } else { ?>
  <INPUT TYPE="SUBMIT" NAME="showports" VALUE="Show">
<?php } ?>
</FORM>
</TD>
<TD>

The open ports table is for reference only.  It lists the currently
open TCP and UDP ports on this machine.  This listing might be of
some use in determining which ports need to be firewalled.
<P>

<?php if ($config[SHOW_PORTS] == "YES") { ?>
<TABLE BORDER=0 BGCOLOR="#EEEEEE" CELLSPACING=2 CELLPADDING=4>
  <TR ALIGN=LEFT VALIGN=TOP>
    <TD><B>Protocol</B></TD>
    <TD><B>Port Number</B></TD>
  </TR>

<?php

#
# Print all of the open ports.
#
function print_port ($proto,$port) {
  print "<TR VALIGN=MIDDLE ALIGN=LEFT>";
  $fs = "<TD>" . service_colour("$port/$proto");
  $ef = "</FONT></TD>";
  print "$fs$proto$ef$fs$port$ef</TR>\n";
}

$portr = popen("/bin/netstat -a", "r");
while (!feof($portr)) {
  $buffer = trim(fgets($portr, 255));
  list ($proto, $rq, $sq, $la, $lp, $fa, $fp, $state) = preg_split ("/[\s:]+/", $buffer);
  if ( ($proto == "tcp") and ($state == "LISTEN") ) {
    print_port ($proto, $lp);
  } elseif ( ($proto == "udp") and ($la == "*") ) {
    print_port ($proto, $lp);
  } elseif ( ($proto == "udp") and ($la == "localhost") ) {
    print_port ($proto, $lp);
  }
}
$term = pclose($portr);

?>

</TABLE>
<?php } ?>

<HR></TD></TR>
 
<?php
#############################################################################
#
# Firewall script.
#
#############################################################################

#
# Generate the file.
#
$fwf = fopen("$CONF/firewall", "w+");

fwrite ($fwf, "#!/bin/sh\n");
fwrite ($fwf, "#\n");
fwrite ($fwf, "# Firewall script generated by the PHP Firewall Generator (phpfwgen).\n");
fwrite ($fwf, "#\n");
fwrite ($fwf, "# PHP Firewall Generator by Del (del@babel.com.au).  Original coding ideas\n");
fwrite ($fwf, "# from IPCHAINS-FIREWALL V1.6.2m by Ian Hall-Beyer (manuka@nerdherd.net)\n");
fwrite ($fwf, "# and various others.\n");
fwrite ($fwf, "#\n");
fwrite ($fwf, '# phpfwgen revision: $Revision: 1.20 $');
fwrite ($fwf, "\n");
fwrite ($fwf, "#\n");
fwrite ($fwf, "# This script is automatically generated.  Edit at your own peril.\n");
fwrite ($fwf, "#\n");
fwrite ($fwf, "# phpfwgen (C) Del under the GPL.\n");
fwrite ($fwf, "#\n");
fwrite ($fwf, "# This script is _not_ copyright to anyone, since it was generated by\n");
fwrite ($fwf, "# software.\n");
fwrite ($fwf, "#\n");
fwrite ($fwf, "#############################################################################\n");
fwrite ($fwf, "# Initialise Firewall Configuration\n");
fwrite ($fwf, "#############################################################################\n");
fwrite ($fwf, "\n");

fwrite ($fwf, "IPCHAINS='/sbin/ipchains'\n");
fwrite ($fwf, "IPMASQADM='/usr/sbin/ipmasqadm'\n");
fwrite ($fwf, "\n");

fwrite ($fwf, "#\n");
fwrite ($fwf, "# Network object definitions.\n");
fwrite ($fwf, "#\n");
fwrite ($fwf, "HIPORTS='1024:65535'\n");
fwrite ($fwf, "\n");

if (is_array($netobjects)) {
  reset($netobjects);
  while ( list( $key, $val ) = each( $netobjects ) ) {
    $exploded = explode (" ", $val);
    fwrite ($fwf, "$key='$exploded[0]/$exploded[1]'\n");
  }
}
fwrite ($fwf, "\n");

fwrite ($fwf, "#\n");
fwrite ($fwf, "# Turn on forwarding and dynamic addressing.\n");
fwrite ($fwf, "#\n");
fwrite ($fwf, "echo 1 > /proc/sys/net/ipv4/ip_forward\n");
fwrite ($fwf, "echo 1 > /proc/sys/net/ipv4/ip_dynaddr\n");
fwrite ($fwf, "\n");

fwrite ($fwf, "#\n");
fwrite ($fwf, "# Turn on anti-spoofing.\n");
fwrite ($fwf, "#\n");
fwrite ($fwf, "for file in /proc/sys/net/ipv4/conf/*/rp_filter; do\n");
fwrite ($fwf, "  echo 1 > \$file\n");
fwrite ($fwf, "done\n");
fwrite ($fwf, "\n");

fwrite ($fwf, "#\n");
fwrite ($fwf, "# Set IP Masquerade timeouts to sensible defaults.\n");
fwrite ($fwf, "#\n");
fwrite ($fwf, "\$IPCHAINS -M -S 7200 10 60\n");
fwrite ($fwf, "\n");

fwrite ($fwf, "#\n");
fwrite ($fwf, "# Flush all rulesets.\n");
fwrite ($fwf, "#\n");
fwrite ($fwf, "\$IPCHAINS -F input\n");
fwrite ($fwf, "\$IPCHAINS -F output\n");
fwrite ($fwf, "\$IPCHAINS -F forward\n");
fwrite ($fwf, "\n");

fwrite ($fwf, "#\n");
fwrite ($fwf, "# Allow loopback interface\n");
fwrite ($fwf, "#\n");
fwrite ($fwf, "\$IPCHAINS -A input -i lo -s \$ALL -d \$ALL -j ACCEPT\n");
fwrite ($fwf, "\$IPCHAINS -A output -i lo -s \$ALL -d \$ALL -j ACCEPT\n");
fwrite ($fwf, "\n");

fwrite ($fwf, "#############################################################################\n");
fwrite ($fwf, "# Begin Rulesets\n");
fwrite ($fwf, "#############################################################################\n");
fwrite ($fwf, "\n");

fwrite ($fwf, "#############################################################################\n");
fwrite ($fwf, "# Forwarding / Masquerading\n");
fwrite ($fwf, "#############################################################################\n");
fwrite ($fwf, "\n");

fwrite ($fwf, "#\n");
fwrite ($fwf, "# Turn off masquerading within masqueraded networks.\n");
fwrite ($fwf, "#\n");

if (is_array($netobjects)) {
  reset($netobjects);
  while ( list($key,$val) = each($netobjects) ) {
    $exploded = explode (" ", $val);
    if ($exploded[2] == "YES") {
      fwrite ($fwf, "\$IPCHAINS -A forward -s \$$key -d \$$key -j ACCEPT\n");
    }
  }
}

fwrite ($fwf, "#\n");
fwrite ($fwf, "# Turn off masquerading of the external interface.\n");
fwrite ($fwf, "#\n");
fwrite ($fwf, "\$IPCHAINS -A forward -s \$GATEWAYNET -d \$ALL -j ACCEPT\n");
fwrite ($fwf, "\n");

fwrite ($fwf, "#\n");
fwrite ($fwf, "# Masquerade all other networks.\n");
fwrite ($fwf, "#\n");

if (is_array($netobjects)) {
  reset($netobjects);
  while ( list($key,$val) = each($netobjects) ) {
    $exploded = explode (" ", $val);
    if ($exploded[2] == "YES") {
      fwrite ($fwf, "\$IPCHAINS -A forward -s \$$key -d \$ALL -j MASQ\n");
    }
  }
}
fwrite ($fwf, "\n");

fwrite ($fwf, "#\n");
fwrite ($fwf, "# Port Forwarding.\n");
fwrite ($fwf, "#\n");

if (is_array($portfwds)) {
  reset($portfwds);
  while ( list($key,$rule) = each($portfwds) ) {
    $rule = chop($rule);
    fwrite ($fwf, "#\n# Rule number $key [ $rule ]\n#\n");
    list ($proto, $source, $sport, $dest, $dport) = preg_split ("/[\s]+/", $rule);
    fwrite ($fwf, "\$IPMASQADM portfw -a -P $proto");
    list ($saddr, $mask, $masq) = preg_split ("/[\s]+/", $netobjects[$source]);
    list ($daddr, $mask, $masq) = preg_split ("/[\s]+/", $netobjects[$dest]);
    fwrite ($fwf, " -L $saddr $sport -R $daddr $dport\n");
  }
}
fwrite ($fwf, "\n");

fwrite ($fwf, "#\n");
fwrite ($fwf, "# Redirectors.\n");
fwrite ($fwf, "#\n");

if (is_array($redirectors)) {
  reset($redirectors);
  while ( list($key,$rule) = each($redirectors) ) {
    $rule = chop($rule);
    fwrite ($fwf, "#\n# Rule number $key [ $rule ]\n#\n");
    list ($source, $dest, $proto, $sport, $dport) = preg_split ("/[\s]+/", $rule);
    fwrite ($fwf, "\$IPCHAINS -A input -p $proto");
    fwrite ($fwf, " -s \$$source -d \$$dest $sport -j REDIRECT $dport\n");
  }
}
fwrite ($fwf, "\n");

fwrite ($fwf, "#\n");
fwrite ($fwf, "# Deny all other forwarding.\n");
fwrite ($fwf, "#\n");
fwrite ($fwf, "\$IPCHAINS -P forward DENY\n");
fwrite ($fwf, "\n");

fwrite ($fwf, "#############################################################################\n");
fwrite ($fwf, "# Input Rules\n");
fwrite ($fwf, "#############################################################################\n");
fwrite ($fwf, "\n");

if (is_array($rules)) {
  reset($rules);
  while ( list($key,$rule) = each($rules) ) {
    $rule = chop($rule);
    fwrite ($fwf, "#\n# Rule number $key [ $rule ]\n#\n");
    list ($source, $dest, $proto, $port, $action, $log) = preg_split ("/[\s]+/", $rule);
    fwrite ($fwf, "\$IPCHAINS -A input");
    if ($proto != "ALL") fwrite ($fwf, " -p $proto");
    if ($proto == "icmp") {
      fwrite ($fwf, " -s \$$source");
      if ($port != "ALL") fwrite ($fwf, " $port");
      fwrite ($fwf, " -d \$$dest");
    } else {
      fwrite ($fwf, " -s \$$source -d \$$dest");
      if ($port != "ALL") fwrite ($fwf, " $port");
    }
    fwrite ($fwf, " -j $action");
    if ($log == "YES") fwrite ($fwf, " -l");
    fwrite ($fwf, "\n");
    #
    # insert a reverse rule for ACCEPT (tcp) packets.
    #
    if (($action == "ACCEPT") and ($proto == "tcp")) {
      fwrite ($fwf, "# Reverse of the preceding rule.\n");
      fwrite ($fwf, "\$IPCHAINS -A input");
      fwrite ($fwf, " -p $proto");
      fwrite ($fwf, " -d \$$source \$HIPORTS -s \$$dest");
      if ($port != "ALL") fwrite ($fwf, " $port");
      fwrite ($fwf, " ! -y -j $action");
      if ($log == "YES") fwrite ($fwf, " -l");
      fwrite ($fwf, "\n");
    }
    #
    # insert a reverse rule for ACCEPT (udp) packets.
    #
    if (($action == "ACCEPT") and ($proto == "udp")) {
      fwrite ($fwf, "# Reverse of the preceding rule.\n");
      fwrite ($fwf, "\$IPCHAINS -A input");
      fwrite ($fwf, " -p $proto");
      fwrite ($fwf, " -d \$$source \$HIPORTS -s \$$dest");
      if ($port != "ALL") fwrite ($fwf, " $port");
      fwrite ($fwf, " -j $action");
      if ($log == "YES") fwrite ($fwf, " -l");
      fwrite ($fwf, "\n");
    }
  }
}
fwrite ($fwf, "\n");

fwrite ($fwf, "#############################################################################\n");
fwrite ($fwf, "# Default Rules\n");
fwrite ($fwf, "#############################################################################\n");
fwrite ($fwf, "\n");

fwrite ($fwf, "#\n");
fwrite ($fwf, "# Default output policy: accept.\n");
fwrite ($fwf, "#\n");
fwrite ($fwf, "\$IPCHAINS -A output -j ACCEPT\n");
fwrite ($fwf, "\$IPCHAINS -P output ACCEPT\n");
fwrite ($fwf, "\n");

fwrite ($fwf, "#\n");
fwrite ($fwf, "# Default input policy: deny and log.\n");
fwrite ($fwf, "#\n");
fwrite ($fwf, "\$IPCHAINS -A input -j DENY -l\n");
fwrite ($fwf, "\$IPCHAINS -P input DENY\n");

fclose($fwf);
?>

<TR><TD ALIGN=left VALIGN=top><B>Current Script</B>
<BR>
E-mail address:
<BR>
<FORM NAME="button" METHOD="POST" ACTION="index.php3">
<INPUT TYPE="TEXT" NAME="emailaddress" SIZE=15 MAXLENGTH=127 VALUE="<?php print "$emailaddress" ?>">
<BR>
<INPUT TYPE="SUBMIT" NAME="sendemail" VALUE="Send">
<BR>
<?php if ($config[SHOW_SCRIPT] == "YES") { ?>
  <INPUT TYPE="SUBMIT" NAME="hidescript" VALUE="Hide">
<?php } else { ?>
  <INPUT TYPE="SUBMIT" NAME="showscript" VALUE="Show">
<?php } ?>
</FORM>
</TD>
<TD>

<PRE>
<?php
if ($config[SHOW_SCRIPT] == "YES") {
  $term = readfile("$CONF/firewall");
}
?>
</PRE>

<HR></TD></TR>
</TABLE>

</BODY>
</HTML>
